#include <Y/object/object.h>
#include <Y/widget/widget.h>
#include <Y/screen/screen.h>
#include <Y/input/pointer.h>
#include <Y/input/arrow.h>
#include <stdlib.h>
#include <stdio.h>

static int pointerX = 0, pointerY = 0;
static struct Widget *pointerWidget = NULL;

void
pointerGrab (struct Widget *w)
{
  pointerWidget = w;
}

void
pointerRelease ()
{
  pointerWidget = NULL;
}

void
pointerGetPosition (int *xp, int *yp)
{
  if (xp != NULL)
    *xp = pointerX;
  if (yp != NULL)
    *yp = pointerY;
}

void
pointerMovePosition (int dx, int dy)
{
  pointerSetPosition (pointerX + dx, pointerY + dy);
}

void
pointerSetPosition (int x, int y)
{
  struct Widget *w;
  int dx;
  int dy;
  screenConstrainPoint (&x, &y);
  dx = x - pointerX;
  dy = y - pointerY;
  if (x == pointerX && y == pointerY)
    return;
  screenInvalidateRectangle (rectangleCreate (pointerX, pointerY, 32, 32));
  pointerX = x;
  pointerY = y;
  if (pointerWidget != NULL)
    {
      w = pointerWidget;
      widgetGlobalToLocal (w, &x, &y);
    }
  else
    w = screenGetRootWidget ();

  screenInvalidateRectangle (rectangleCreate (pointerX, pointerY, 32, 32));

  widgetPointerMotion (w, x, y, dx, dy);
}

void
pointerButtonChange (int button, int pressed)
{
  struct Widget *w;
  int x = pointerX;
  int y = pointerY;

  if (pointerWidget != NULL)
    {
      w = pointerWidget;
      widgetGlobalToLocal (w, &x, &y);
    }
  else
    w = screenGetRootWidget ();

  widgetPointerButton (w, x, y, button, pressed);

}


/* arch-tag: 64b8b5ba-85b7-47cc-a69d-9bc90707c923
 */
