#ifndef Y_MODULES_VIDEODRIVER_INTERFACE_H
#define Y_MODULES_VIDEODRIVER_INTERFACE_H

#include <Y/y.h>
#include <Y/modules/module.h>
#include <Y/screen/renderer.h>
#include <Y/util/rectangle.h>
#include <Y/object/parameters.h>
#include <stdint.h>

struct VideoResolution
{
  char *name;
};

struct VideoDriver
{
  struct Module *module;
  void *d;
  void (*getPixelDimensions) (struct VideoDriver *, int*, int*);
  const char *
       (*getName)            (struct VideoDriver *);
  struct List *
       (*getResolutions)     (struct VideoDriver *);
  void (*setResolution)      (struct VideoDriver *, const char *name);
  void (*special)            (struct VideoDriver *, struct Parameters *);

  void (*beginUpdates)       (struct VideoDriver *);
  void (*endUpdates)         (struct VideoDriver *);

  void (*drawPixel)          (struct VideoDriver *, uint32_t, int, int);
  void (*drawRectangle)      (struct VideoDriver *, uint32_t, int, int, int, int);
  void (*drawFilledRectangle)(struct VideoDriver *, uint32_t, int, int, int, int);

  void (*blit)               (struct VideoDriver *, uint32_t *,
                              int, int, int, int, int);

  struct Renderer * (*getRenderer) (struct VideoDriver *,
                                    const struct Rectangle *);

};

#endif

/* arch-tag: 5f5c7173-7eb3-4465-820d-1b1452eaf910
 */
