
#ifndef Y_OBJECT_CLASS_H
#define Y_OBJECT_CLASS_H

struct Class;

#include <Y/y.h>
#include <Y/object/parameters.h>
#include <Y/object/object.h>
#include <Y/message/message.h>

void classInitialise ();
void classFinalise ();

const char *classGetName      (struct Class *);
int         classGetID        (struct Class *);
int         classInherits     (struct Class *, const char *classname);
void        classInvokeMethod (struct Class *, struct Object *,
                               const char *method, struct Parameters *);

void          classRegister   (struct Class *);
struct Class *classFindByName (const char *name);
struct Class *classFindByID   (int id);

struct Object *classInstantiate (struct Class *, struct Client *,
                                 struct Parameters *);

void        classDespatch     (struct Class *, struct Object *, struct Message *); 

#endif

/* arch-tag: 40076502-2ce7-447b-a515-8c9614be70de
 */
