
#ifndef Y_OBJECT_CLASS_P_H
#define Y_OBJECT_CLASS_P_H

#include <Y/y.h>
#include <Y/object/class.h>
#include <Y/object/object.h>
#include <Y/object/parameters.h>
#include <Y/object/property.h>


struct Method
{
  const char *name;
  void      (*m)(struct Object *, struct Parameters *);
};

struct Class
{
  const char *       name;
  int                id;
  struct Class *     super;
  struct Object *  (*instantiate)(struct Parameters *);
  void             (*destroy)(struct Object *);
  void             (*despatch)(struct Object *, struct Message *);
  int                methodCount;
#if __GNUC__ >= 3
  struct Method      methods[]; 
#else
# ifndef CLASS_MAX_METHODS
#  define CLASS_MAX_METHODS 64
# endif
  struct Method      methods[CLASS_MAX_METHODS];
#endif
};

/* NOTA BENE:  method names must be sorted in     *
 *             strcmp order, as they will be      *
 *             searched using a bsearch call.     */

#endif


/* arch-tag: 704424e8-5652-46b0-b91f-0a921253d6f8
 */
