#ifndef Y_OBJECT_PROPERTY_H
#define Y_OBJECT_PROPERTY_H

struct Property;

#include <Y/y.h>

struct Property *propertyCreate (const char *name);
void             propertyDestroy (struct Property *);

/* to allow properties to be stored in an Index */
int propertyKeyFunction (void *key, void *obj);
int propertyComparisonFunction (void *obj1, void *obj2);
void propertyDestructorFunction (void *obj);

const char *propertyGetAsString (struct Property *);
int         propertyGetAsInteger (struct Property *);

void        propertySetToString (struct Property *, const char *);
void        propertySetToInteger (struct Property *, int);

typedef void (*PropertyCallback_t)(struct Property *, void *);

void        propertyCallOnSet (struct Property *, void *data,
                               PropertyCallback_t callback);
void        propertyCallOnGet (struct Property *, void *data,
                               PropertyCallback_t callback);

#endif /* header guard */

/* arch-tag: 2452bff4-1761-442c-8f1c-29fb885c772b
 */
