#ifndef Y_SCREEN_RENDERERCLASS_H
#define Y_SCREEN_RENDERERCLASS_H

#include <Y/screen/renderer.h>

/* This defines the internal characteristics of an ABSTRACT Renderer */

struct Renderer
{
  struct RendererClass *c;
  struct List *regions;
};

struct RendererClass
{
  char *name; /* may be used for rtti */
  void (*complete)     (struct Renderer *);
  void (*destroy)      (struct Renderer *);
  void (*blitRGBAData) (struct Renderer *, int, int, uint32_t *,
                        int, int, int);
  void (*drawFilledRectangle) (struct Renderer *, uint32_t,
                               int, int, int, int);
};

void rendererInitialise (struct Renderer *);

#endif /* Y_BUFFER_RENDERERCLASS_H */

/* arch-tag: 8db4f7cf-02c0-4a5a-b228-a2b16361b54f
 */
