struct Rectangle;

#ifndef Y_UTIL_RECTANGLE_H
#define Y_UTIL_RECTANGLE_H

struct Rectangle
{
  int x, y, w, h;
};

#include <Y/util/list.h>

struct Rectangle *rectangleCreate (int x, int y, int w, int h);
struct Rectangle *rectangleDuplicate (const struct Rectangle *);
void              rectangleDestroy (struct Rectangle *);

/* dest may equal src1 or src2, e.g.
 *         rectangleUnion (r1, r1, r2)  <->  r1 = r1 U r2 */

/* returns 1 if Union reduces total area */
int rectangleUnion     (struct Rectangle *dest,
                        const struct Rectangle *src1, const struct Rectangle *src2);

/* returns 1 if they intersected at all */
int rectangleIntersect (struct Rectangle *dest,
                        const struct Rectangle *src1, const struct Rectangle *src2);

/* unions rectangles if they overlap */
void  rectanglelistUnionOverlaps (struct List *);

/* get a list of intersecting rectangles */
struct List *rectanglelistIntersectWith (struct List *src1, struct List *src);

#endif


/* arch-tag: a8754b11-0bb6-4acb-bec6-9d11ca967910
 */
