
#include "libY.h"
#include "internal.h"
#include <stdio.h>
#include <stdlib.h>

void (*libY_sendMessage) (struct Message *) = NULL;
int  (*libY_recvMessage) (struct Message *, int) = NULL;

void
yInitialise ()
{

  char *display = getenv ("YDISPLAY");

  if (display == NULL)
    display = "unix:/tmp/.Y-0";

  libY_initialise ();

  if (libY_unixInitialise (display))
    {
      return;
    }
  else if (libY_tcpInitialise (display))
    {
      return;
    }
  else
    {
      fprintf (stderr, "libY: Could not establish link to server at %s\n", 
               display);
      abort ();
    }
}

void
yFinalise ()
{
  libY_finalise ();
  libY_unixFinalise ();
  libY_tcpFinalise ();
}

void
ySend (struct Message *m)
{
  libY_sendMessage (m);
}

int
yReceive (struct Message *m, int timeout)
{
  return libY_recvMessage (m, timeout);
}

/* arch-tag: 8765372f-c931-420c-9cd8-bb50f688575b
 */
