#ifndef Y_LIBY_H
#define Y_LIBY_H

#ifdef __cplusplus
extern "C" {
#endif

#include <Y/const.h>

struct Message
{
  int to, from, cid, oid;
  int op, meta, ext, len;
  char *data;
};

void   yInitialise ();
void   yFinalise ();

void   ySend        (struct Message *req);

/* returns 1 if a message was actually received
 */
int    yReceive     (struct Message *rep, int timeout);

enum YListenMode
{
  Y_LISTEN_READ = 1<<0,
  Y_LISTEN_WRITE = 1<<1,
  Y_LISTEN_EXCEPT = 1<<2,
};

void   yRegisterFD (int fd, int mask, void *data, void (*call)(int, int, void*));
void   yChangeFD (int fd, int mask);
void   yUnregisterFD (int fd);

#ifdef __cplusplus
}
#endif

#endif /* header guard */

/* arch-tag: bb44168c-4ac8-4b2f-9e9c-12cd0f17cbd0
 */
