#ifndef Y_CPP_CANVAS_H
#define Y_CPP_CANVAS_H

#include <Y/c++/widget.h>
#include <stdint.h>
#include <sigc++/signal_system.h>

namespace Y
{
  class Canvas : public Widget
  {
    public:
      Canvas ();
      virtual ~Canvas ();

      void savePainterState ();
      void restorePainterState ();
      void setBlendMode ();
      void setPenColour (uint32_t);
      void setFillColour (uint32_t);
      void reset (int &newWidth, int &newHeight);
      void clearRectangle (int x, int y, int w, int h);
      void drawRectangle (int x, int y, int w, int h);
      void drawHLine (int x, int y, int dx);
      void drawVLine (int x, int y, int dy);
      void drawLine (int x, int y, int dx, int dy);
      void drawHLines (int n, ...);
      void drawVLines (int n, ...);
      void drawLines (int n, ...);
      void setBufferSize (int w, int h);
      void swapBuffers ();
      void requestSize (int w, int h);

      SigC::Signal0<void> resize;

    protected:
      virtual void onEvent (const string &, const vector<string> &);

    private:
      static int canvasClassId;
  };
}

#endif

/* arch-tag: 6a8c0c24-4328-43de-94b6-fc2053533128
 */
