#ifndef Y_CPP_PROPERTY_H
#define Y_CPP_PROPERTY_H

#include <Y/libY.h>


namespace Y
{

  class Property
  {
  private:
    Object *owner;
    string name;
    string value;

  public:
    inline
    Property (const string& n, const string& v)
    : name (n), value (v) { }

    inline Property &
    operator= (const char *v)
      {
        cout << "Property: " << name << " set to " << v << endl;
        owner -> setProperty (name, v); 
        return *this;
      }

    inline Property &
    operator= (const string &v)
      {
	cout << "Property: " << name << " set to " << v << endl;
        owner -> setProperty (name, v); 
	return *this;
      }

    inline
    operator string() const
      {
	cout << "Property: " << name << " accessed as string." << endl;
	return owner -> getProperty (name);
      }

    inline string
    operator () const
      {
        cout << "Property: " << name << " accessed as function." << endl;
        return owner -> getProperty (name);
      }
  };
}

#endif

/* arch-tag: 9e875103-cd32-449e-94f6-836618ffb0aa
 */
