
#include <Y/modules/module_interface.h>
#include <Y/modules/theme_interface.h>

#include <Y/util/yutil.h>

#include <Y/buffer/painter.h>

void
basicDrawBackgroundPane (struct Painter *painter, int x, int y, int w, int h)
{
}

void
basicDrawButtonPane (struct Painter *painter, int x, int y, int w, int h,
                     enum WidgetState state)
{
  painterSaveState (painter);
  painterSetBlendMode (painter, COLOUR_BLEND_SOURCE_OVER);
  painterSetPenColour (painter, 0xFF000000);
  if (state == WIDGET_STATE_HOVER
      || state == WIDGET_STATE_PRESSED
      || state == WIDGET_STATE_CANCELLING)
    painterSetFillColour (painter, 0x40FFFFFF);
  else
    painterSetFillColour (painter, 0x00000000);
  painterDrawRectangle (painter, x, y, w, h);
  if (state == WIDGET_STATE_PRESSED)
    painterSetPenColour (painter, 0x80000000);
  else
    painterSetPenColour (painter, 0x80FFFFFF);
  painterDrawHLine (painter, x+1, y+1, w-2);
  painterDrawVLine (painter, x+1, y+2, h-2);
  if (state == WIDGET_STATE_PRESSED) 
    painterSetPenColour (painter, 0x80FFFFFF);
  else
    painterSetPenColour (painter, 0x80000000);
  painterDrawHLine (painter, x+2, y+h-2, w-3);
  painterDrawVLine (painter, x+w-2, y+1, h-3);
  painterRestoreState (painter);
  if (state == WIDGET_STATE_PRESSED)
    painterTranslate (painter, 1, 1);
}

/* arch-tag: 87b56315-7ef3-4569-8091-45b21653c601
 */
